]> git.pld-linux.org Git - packages/apache.git/blobdiff - apache.init
- Vary on User-Agent is insame, Vary on Accept-Encoding instead, also decaces old...
[packages/apache.git] / apache.init
index 922ef7f188e8f078e2ba6d9b867b853e45e1c3dd..c9a99147847e5c231de9c64acd5fb3723389a2a2 100644 (file)
@@ -7,10 +7,7 @@
 #              HTML files and CGI.
 # processname: httpd
 # pidfile:     /var/run/httpd.pid
-# config:      /etc/httpd/conf/access.conf
-# config:      /etc/httpd/conf/httpd.conf
-# config:      /etc/httpd/conf/srm.conf
-
+# config:      /etc/httpd/apache.conf
 
 # Source function library
 . /etc/rc.d/init.d/functions
 . /etc/sysconfig/network
 
 # Get service config
-[ -f /etc/sysconfig/apache ] && . /etc/sysconfig/apache
+[ -f /etc/sysconfig/httpd ] && . /etc/sysconfig/httpd
 
 # Check that networking is up.
-if [ "${NETWORKING}" = "no" ]; then
-       echo "WARNING: Networking is down. Apache can't be runed."
-       exit 1
+if is_yes "${NETWORKING}"; then
+       if [ ! -f /var/lock/subsys/network -a "$1" != stop -a "$1" != status ]; then
+               msg_network_down "Apache 2.2 Web Server"
+               exit 1
+       fi
+else
+       exit 0
 fi
 
-# See how we were called.
-case "$1" in
-  start)
+[ -z "$HTTPD_MPM" ] && HTTPD_MPM="prefork"
+SVC_NAME="Apache 2.2 Web Server ($HTTPD_MPM)"
+
+if [ -n "${HTTPD_CONF}" ]; then
+       if [ -d "${HTTPD_CONF}" ] || [ -f "${HTTPD_CONF}" ]; then
+               CFG="-f ${HTTPD_CONF}"
+       else
+               echo "error: HTTPD_CONF='$HTTPD_CONF': not a file, not a directory"
+               exit 1
+       fi
+fi
+
+# configtest itself
+configtest() {
+       /usr/sbin/httpd.${HTTPD_MPM} -t $CFG $HTTPD_OPTS 2>&1
+       return $?
+}
+
+# wrapper for configtest:
+checkconfig() {
+       local details=${1:-0}
+
+       if [ $details -eq 1 ]; then
+               # run config test and display report (status action)
+               show "Checking %s configuration" "$SVC_NAME"; busy
+               local out
+               out=`configtest 2>&1`
+               RETVAL=$?
+               [ $RETVAL -eq 0 ] && ok || fail
+               [ "$out" ] && echo >&2 "$out"
+       else
+               # run config test and abort with nice message if failed
+               # (for actions checking status before action).
+               show "Checking %s configuration" "$SVC_NAME"; busy
+               configtest >/dev/null 2>&1
+               RETVAL=$?
+               if [ $RETVAL -eq 0 ]; then
+                       ok
+               else
+                       fail
+                       nls 'Configuration test failed. See details with %s "checkconfig"' $0
+                       exit $RETVAL
+               fi
+       fi
+}
+
+start() {
        # Check if the service is already running?
+       if [ -f /var/lock/subsys/httpd ]; then
+               msg_already_running "$SVC_NAME"
+               return
+       fi
+
+       [ "$1" -eq 0 ] || checkconfig
+       msg_starting "$SVC_NAME"
+       daemon --pidfile /var/run/httpd.pid /usr/sbin/httpd.${HTTPD_MPM} $CFG $HTTPD_OPTS
+       RETVAL=$?
+       [ $RETVAL -eq 0 ] && touch /var/lock/subsys/httpd
+}
+
+stop() {
+       # Stop daemons.
        if [ ! -f /var/lock/subsys/httpd ]; then
-               show Starting httpd
-               daemon httpd
-               touch /var/lock/subsys/httpd
-       else
-               echo "httpd already is running"
+               msg_not_running "$SVC_NAME"
+               return
        fi
+
+       msg_stopping "$SVC_NAME"
+       killproc --pidfile /var/run/httpd.pid httpd.${HTTPD_MPM}
+       rm -f /var/lock/subsys/httpd /var/run/httpd.pid /var/run/httpd.loc* >/dev/null 2>&1
+}
+
+
+reload() {
+       if [ ! -f /var/lock/subsys/httpd ]; then
+               msg_not_running "$SVC_NAME"
+               RETVAL=7
+               return
+       fi
+
+       checkconfig
+       msg_reloading "$SVC_NAME"
+       busy
+       /usr/sbin/httpd.${HTTPD_MPM} $CFG $HTTPD_OPTS -k graceful
+       RETVAL=$?
+       [ $RETVAL -eq 0 ] && ok || fail
+}
+
+condrestart() {
+       if [ ! -f /var/lock/subsys/httpd ]; then
+               msg_not_running "$SVC_NAME"
+               RETVAL=$1
+               return
+       fi
+
+       checkconfig
+       stop
+       start
+}
+
+RETVAL=0
+# See how we were called.
+case "$1" in
+  start)
+       start
        ;;
   stop)
-       show Shutting down httpd
-       killproc httpd  
-       rm -f /var/lock/subsys/httpd /var/run/httpd.pid /var/run/httpd.loc*
+       stop
        ;;
-  status)
-       status httpd
-       /usr/sbin/httpd -S
+  restart)
+       checkconfig
+       stop
+       start 0
        ;;
-  restart|reload)
-       $0 stop
-       $0 start
+  try-restart)
+       condrestart 0
+       ;;
+  reload|force-reload|graceful|flush-logs)
+       reload
+       ;;
+  checkconfig|configtest)
+       checkconfig 1
+       ;;
+  status)
+       status httpd.${HTTPD_MPM}
+       RETVAL=$?
+       /usr/sbin/httpd.${HTTPD_MPM} $CFG $HTTPD_OPTS -S
        ;;
   *)
-       echo "Usage: $0 {start|stop|restart|status}"
-       exit 1
+       msg_usage "$0 {start|stop|restart|try-restart|reload|force-reload|graceful|configtest|status}"
+       exit 3
        ;;
 esac
 
-exit 0
+exit $RETVAL
This page took 0.043406 seconds and 4 git commands to generate.